//
// C Header for:
//     TI-OS and Kernel routines in Fargo II
//
// Bryan Turner
//

#ifndef _TIOS_
#define _TIOS_

// Text coloring
#define PLAIN 4
#define DIMMED 3
#define INVERSE 0

// Text sizes
#define TINY 0
#define MEDIUM 1
#define LARGE 2

// Activity Modes
#define IDLE 0
#define BUSY 1
#define PAUSE 2

// Global Vars
#define TI_main_lcd	0x00004440
#define TI_SF_font	0x00465FC4
#define TI_kb_vars	0x00007594
#define TI_ST_flags	0x0000761C


//short TI_ER_catch(void *ErrorFrame);
//void TI_ER_success(void);
void TI_ST_busy(short mode);
void TI_ST_redraw(void);
void TI_ST_message(char *message);
void TI_HeapFreeIndir(short *handle);
void TI_HeapFree(short handle);
short TI_HeapAlloc(long size);
//short TI_HeapAllocThrow(long size);
short TI_HeapRealloc(short handle, long newsize);
void TI_DrawStrXY(short x, short y, char *string, short theColor);
void TI_DrawCharXY(short ch, short x, short y, short theColor, short what1, short what2, short what3);
char TI_FontSetSys(short font);
short TI_sprintf(char *buffer, char *format, ...);
void TI_vcbprintf(void func(char, void **), void **param, char *format, void *va_list);
short TI_strcmp(char *s1, char *s2);
long TI_strlen(char *s);
short TI_strncmp(char *s1, char *s2, short n);		// 'n' is a size_t, is that a short or long?
char *TI_strncpy(char *dest, char *src, short n); // 'n' is a size_t, is that a short or long?
char *TI_strcat(char *dest, char *src);
char *TI_strchr(char *s, short c);
short *TI_FindSymEntry(short symlist, char *name); // returns SYM_ENTRY *


// Routines in Kernel Lib
// Since the addresses of these change each time fargo is released, be sure
//    your TIOSGlue.h version matches your fargo version!
//short exec(short hand);


#endif

