#include <Globals.h>

// BT: System call to replace: chprio, getpid, getprio, & setnok
// Calls to these functions will be mapped to this one with correct input
SYSCALL GetSetState( PROC_ID theProcess, long data, short what )
{
	//
	// what = 0 Priority
	// what = 1 Next Of Kin
	//
	// theProc < 0 == getpid()
	// theProc = 0 : get/set prio or pnxtkin of current proc
	// theProc > 0 : get/set " or " of another proc
	//
	short	sr;    
	int		ret;
	long	a4;
	Process *theProc;
	
	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	if ( (char *)theProcess < (char *)0 )			// Special flag
		ret = (WORD)xinuGlobs.CurPID;
	else
		{
		if ( (char *)theProcess > (char *)0)		// Some other process..
		 	{
		 	theProc = ((Process *)theProcess);
		 	
		 	if (isbadpid(theProc) || theProc->pstate == PRFREE)
				return(SYSERR);
		 	}
		else										// Current process
			theProc = ((Process *)xinuGlobs.CurPID);
		
		if ( what )									// What > 0 for Next Of Kin
			{
			if ( data > 0 )
				theProc->pnxtkin = (PROC_ID)data;
			ret = OK;
			}
		else
			{
			ret = theProc->pprio;
			if ( data > 0 )							// Priority must be > 0
				{
				theProc->pprio = data;
				switch (theProc->pstate)
				{
				case PRREADY:
					InsertByKey( (PROC_ID)Dequeue( (Q_NODE)theProcess ), xinuGlobs.readyQ, data );
				case PRCURR:
					resched();
				}
				}
			}
		}
	
	RestoreA4AndSR(a4,sr);
	return(ret);	
}
