/* proc.h - isbadpid */

/* process table declarations and defined constants			*/

#ifndef _PROC_
#define	_PROC_

// Max number of procs (BT: not relevent when dynamic Xinu memory is used)
#define	NPROC		15

/* process state constants */

#define	PRFREE		'\002'		/* process slot is free		*/
#define	PRCURR		'\001'		/* process is currently running	*/
#define	PRREADY		'\003'		/* process is on ready queue	*/
#define	PRSUSP		'\006'		/* process is suspended		*/
#define	PRWAIT		'\007'		/* process is on semaphore queue*/
#define	PRSLEEP		'\005'		/* process is sleeping		*/
#define	PRTRECV		'\010'		/* process is timing a receive	*/
#define	PRRECV		'\004'		/* process waiting for message	*/


/* miscellaneous process definitions */

#define	isbadpid(x)	( ((QItem *)(x))->flags != PROC_FLAG )

// Process Structure
typedef struct	{
	QItem	qhand;
	// Message Data
	Q_ID	msgQueue;		// Queue of messages pending
	
	// Process Data
	char	pstate;			// process state: PRCURR, etc.
	short	pprio;			// process priority	
	SEM_ID	psem;			// Semaphore ID of the semaphore bieng waited on...
	
	// Stack Data
	short	pstklen;		// stack length
	WORD	pbase;			// base of run time stack
	//WORD	plimit;			// lowest extent of stack --- BT: Is this used much?
	WORD	pcurstack;		// Current Stack Address (registers saved on top + PC)
		
	// Misc. Data
	PROC_ID	pnxtkin;		// Next of Kin : Send message to given proc when curproc is killed
} Process;

#endif

