/* slu.h */

#define EVEC_LEVEL1     0x64

/*
 * Delay units are in microseconds.
 */

// This variable is used in the DELAY macro.  5 is the right value for
// 68010's running 10MHz.  3 is the right value for 68020's running 16MHz
// with cache on.  (4x as fast at doing the delay loop.)  Other values
// should be empirically determined as needed.  Srt0.s sets this value
// based on the actual runtime environment encountered.
//
// It's critical that the value be no SMALLER than required, e.g. the
// DELAY macro guarantees a MINIMUM delay, not a maximum.

// Multiplier for DELAY macro.
#define CPUDELAY 5

#define	DELAY(n)	\
{ \
	register int N = (((n)<<4) >> CPUDELAY); \
 \
	while (--N > 0) ; \
}*

/*#define	DELAY(n)	\
{ \
        extern int cpudelay; \
	register int N = (((n)<<4) >> cpudelay); \
 \
	while (--N > 0) ; \
}*/



