
#include <Globals.h>

extern void sysinit();
extern void main( void );
extern void ctxsw(long *oregs, long *nregs);
extern void actualGlobals();

//
// Startup code for TI-92 Xinu version 7
//

asm void myCode()
{
// Xinu Startup Code, runs as a Fargo II program
//
// Fargo programs run in USER mode usually.
// To fix this, we'll install a routine which switches to supervisor mode for us.
//
	bclr	%2,0x600001		// Clear the memory protect bit
	
	move.l	(0x5D36),a0		// Load pointer to top of RAM
	lea		main,a1
	lea		supervisor,a2
	suba.l	a2,a1
	move.l	a1,d0			// Load size of program
	sub.l	d0,a0			// Calculate installation address
	move.l	a0,(0x5D36)
	lsr.l	#2,d0			// Bytes -> Longwords
	subq	#1,d0
	move.l	a0,0xB8			// Adjust trap #14 vector
	
copy_lup:
	move.l	(a2)+,(a0)+		// Copy Xinu to high memory
	dbra	d0,copy_lup
	
	trap	%14				// Force exception : Jumps to 'supervisor' below...
	
	bset	%2,0x600001		// Memory Protect ON
	
	rts						// Reurn to Fargo
	
supervisor:

//
// Now we can play!  First, disable interrupts, and then get to setting up the system.
//
	move.w	%0x2700,sr				// Disable interrupts
	lea		actualGlobals,a4		// Load globals
//
// Find out how much memory we have...
//
lup:
	move.l	0x5D36,a0		// BT: top of memory --- NOT ROM 2.1 compatable!! (they have more RAM)
	
	// Start Xinu
	jsr		sysinit
	
	rte						// Return to caller (Fargo probably)
}

//
