/* chprio.c - chprio */

#include <Globals.h>

/*------------------------------------------------------------------------
 * chprio  --  change the scheduling priority of a process
 *------------------------------------------------------------------------
 */


SYSCALL chprio( PROC_ID theProcess, short newprio)
{
	short sr;    
	int	oldprio;
	long a4;
#define theProc ((Process *)theProcess)

	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	if (isbadpid( theProcess ) || newprio <= 0 ||
	    theProc->pstate == PRFREE)
	    {
		RestoreA4AndSR(a4,sr);
		return(SYSERR);
		}
		
	oldprio = theProc->pprio;
	theProc->pprio = newprio;
	switch (theProc->pstate)
	{
	case PRREADY:
		InsertByKey( (PROC_ID)Dequeue( (Q_NODE)theProcess ), xinuGlobs.readyQ, newprio );
	case PRCURR:
		resched();
	}
	
	RestoreA4AndSR(a4,sr);
	return(oldprio);
}
