/* evec.c -- initevec, doevec, trapX */

#include <Globals.h>  

void trapX();

asm void initevec()
{
	// BT: This function will not need to save the old traps!
	//     They will never be used again, since you cannot uninstall Xinu.
	fralloc
	lea		traps,a0
	lea		trapX,a1
	clr.l	d1
	
evec_lup:
	move.b	(a0)+,d1		// Load trap offset (one byte)
	movea.l	d1,a2			// Convert to address
	move.l	a1,(a2)			// Install new trap
	move.b	d1,(a2)			// Place trap number in high byte
	tst.b	(a0)
	bne		evec_lup
	
	frfree
	rts
traps:
	dc.b	0x08,0x0c,0x10,0x14,0x18,0x1c,0x20,0x24,0x2c
    dc.b	0x60,0x6c,0x7c,0xac,0xb0,0xb4,0xb8,0xbc, 0x00

}

// Bryan: used to get the PC of the current process.. often very usefull.
/*
asm long getPC()
{
	move.l	(sp),d0		// Load return address from stack.  We're done!
	rts
}*/

asm void LoadGlobals()
{
	lea	actualGlobals,A4
	rts
}

asm long SaveA4AndLoadGlobals()
{
	move.l	a4,d0
	lea		actualGlobals,A4
	rts
}

asm void RestoreA4( long a4 )
{
	movea.l	4(a7),a4
	rts
}

asm void RestoreA4AndSR( long a4, short sr )
{
//
// 0: return addr
// 4: A4
// 8: SR
//
	move.l	4(a7),a4
	move.w	8(a7),d0
	trap	%1
	rts
}

short doevec( long curpc )
{
// BT: Disabled all the Xinu Exception handling for recovery testing...
//     OK, I lied, this stuff just doesn't work and I'm ashamed of it.. :)

    //unsigned short sr;
    //unsigned long pc;
    unsigned short vector;
    //long evnum,top,next;
    //char *c;
    //long *stack;
    
    LoadGlobals();					// Load globals
    *((short *)0x600010) = 0x0888;	// Restore Screen to normal position
    
    //
    // --- BT: Display dialog with error & xinu process number/name?
    // BT: Kill offending process if it is Xinu Proc, else call A-Trap restore for TI-Proc
	//     then reschedule..
	//
    
    // Bryan: we stored vector number in upper byte of vector address, to retrieve it,
    //        get our current PC...
    
    vector = curpc >> 24;
    
    kprintf( "Error: %lx  ", vector );
    panic("Xinu Trap!  ");
    //kprintf("sr: 0x%x  ", sr);
    //kprintf("exception: 0x%lx  ", curpc);
    //kprintf("pc: 0x%lx",pc);
    /*
    top = *(stack++);
    next = *(stack++);
    kprintf("Stack: %lx, %lx", top, next );
    top = *(stack++);
    next = *(stack++);
    kprintf("       %lx, %lx", top, next );
    top = *(stack++);
    next = *(stack++);
    kprintf("       %lx, %lx", top, next );
    top = *(stack++);
    next = *(stack++);
    kprintf("       %lx, %lx", top, next );
    kprintf("Trap definition: ");
	*/
	
	/*
    evnum = vector >> 2;	// Divide by 4
    if (evnum<32)
		{
		switch(evnum)
			{
		    case  2: c = "Bus Error"; break;
		    case  3: c = "Address Error"; break;
		    case  4: c = "Illegal Instruction"; break;
		    case  5: c = "Divide by 0\n"; break;
		    case  6: c = "CHK exception"; break;
		    case  7: c = "TRAPV trap"; break;
		    case  8: c = "Privilege Violation"; break;
		    case  9: c = "Trace"; break;
		    case 11: c = "F-Line Emulator"; break;

		    case 15: c = "Uninitialized Interrupt"; break;

		    case 24: c = "Spurrious Interrupt"; break;
		    default: c = "Unassigned"; break;
		  }
		 
		}
    else if (evnum<48)
		{
		kprintf("Trap #%x trap",(evnum-32));
		c="";
		}
    else if (evnum<64)
		c = "Unassigned";

	kprintf("%s", c);
	*/
    //panic("Trapped!");
    
    // BT: return wether to kill or call ER_Throw
    return ( xinuGlobs.CurPID == xinuGlobs.TIPROC );
}

asm void trapX()
{
	move.w	%0x2700,sr
	movem.l	d0-d2/a0-a1,-(a7)	// Save registers
	
	bsr		getpc
	nop
getpc:
	jsr		doevec
	addq	%4,a7
	
	//
	// Must fix supervisor stack before returning!!
	//
	movem.l	(a7)+,d0-d2/a0-a1
	addq	%6,a7				// Pop off SR and PC from exception call
	
	// Was the faulting program TIPROC, or a Xinu process?
	tst.w	d0
	beq		killit
	
    // If it's from TI-OS, call ER_Throw, hopefully popping off the state and continuing...
	pea		ti_throw			// Create exception frame
	clr.w	-(a7)				// With user mode enabled
	rte							// Then return (to ti_throw)
ti_throw:
	dc.w	0xA001				// ER_Throw

killit:	
    pea		INITRET				// User Return == Kill Ourselves
	rts

origStack:
	dc.l	0
}

