/* kill.c - kill */


#include <Globals.h>

/*------------------------------------------------------------------------
 * kill  --  kill a process and remove it from the system
 *------------------------------------------------------------------------
 */

SYSCALL kill( PROC_ID theProcess )	
{
	short	pstate;
	short	sr;
	long	a4;    
#define theProc ((Process *)theProcess)
	
	pstate = theProc->pstate;
	if ( isbadpid(theProcess) || pstate == PRFREE)
		return(SYSERR);
	
	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	send( theProc->pnxtkin, (long)theProcess );

	freestk(theProc->pbase, theProc->pstklen);
	switch (pstate)
	{
	case PRWAIT: // Proc is dequeued from semaphore list in next step...
			((QItem *)(theProc->psem))->key++;

	case PRREADY:
			Dequeue( (Q_NODE)theProcess );
			// BT: collated pstate assignment below...
			break;

	case PRSLEEP:
	case PRTRECV:
			unsleep( theProcess );
	
	// BT: Modified structure, moved pstate assignment from default to below...
	}
	theProc->pstate = PRFREE;
	theProc->qhand.flags = Q_FLAG;
	
	if ( pstate == PRCURR )
		// --- BT: resched will bomb: stack has been deleted, but stuff will be stored onto it!
		// BT: should be fixed.. test it!
		// --- BT: Does this need a restore A4 or SR? - test it!
		resched();
		
	RestoreA4AndSR(a4,sr);
	return(OK);
}

//
// Called when a process terminates by itself
//
void userret()
{
	kill((PROC_ID)getpid());
}
