/* recvtim.c - recvtim */

#include <Globals.h>

/*------------------------------------------------------------------------
 *  recvtim  -  wait to receive a message or timeout and return result
 *------------------------------------------------------------------------
 */
//
// BT: New receive func, combines receive, recvtim, & recvclr
// Wait > 0 : 10ths of seconds to sleep ( recvtim() )
// Wait < 0 : Don't wait at all ( recvclr() )
// Wait = 0 : Same as original receive()
//
SYSCALL	receive( short maxwait )
{
	short	sr; 
	long	a4;    
#define curProc ((Process *)xinuGlobs.CurPID)
	int		msg;

	a4 = SaveA4AndLoadGlobals();
	sr = disable();

	if ( (maxwait >= 0) &&				// IF maxwait not negative
		 isempty(curProc->msgQueue) )	// AND no message in queue...
		{
		if ( maxwait ) 				// AND wait time > 0 specified..
			{						// THEN put on sleep queue
			maxwait <<= 1;			// Multiply by value of QUANTUM to get 1/10 second intervals
		    InsertByDelta( xinuGlobs.CurPID, xinuGlobs.sleepQ, maxwait );
			areProcsAsleep = TRUE;
			sltop = &(((QItem *)((char *)(xinuGlobs.sleepQ) + ((QItem *)(xinuGlobs.sleepQ))->next))->key);
		    curProc->pstate = PRTRECV;	// Timed recieve /w sleep
		    }
		else
			curProc->pstate = PRRECV;	// Permanent block
		
		// IF maxwait >= 0, then wait for message...
		resched();
		}
	
	// Some inefficiency for maxwait < 0 here, since we're checking the
	// msgQueue twice, but required for maxwait > 0.  Sigh..
	if ( nonempty(curProc->msgQueue) )
		{
		
		QItem *qItm = (QItem *)GetFirst(curProc->msgQueue);
		msg = *((long *)&qItm->flags);	// BT: flags, size, and key makeup message data
		qItm->size = 0;					// Fix size byte before freeing
		//XMemFree(qItm);					// Free the block
		}
	else if ( maxwait > 0 )				// still no message, then TIMEOUT
		msg = TIMEOUT;
	else
		msg = OK;						// For maxwait < 0
	
	RestoreA4AndSR(a4,sr);
	return(msg);
}


