/* sdelete.c - sdelete */

#include <Globals.h>

/*------------------------------------------------------------------------
 * sdelete  --  delete a semaphore by releasing its table entry
 *------------------------------------------------------------------------
 */


SYSCALL sdelete( SEM_ID theSemaphore )
{
	short sr; 
	long a4;    
	PROC_ID theProc;
#define theSem ((QItem *)theSemaphore)


	if ( isbadsem(theSem) 
		//|| theSem->key == SFREE	BT: No harm in freeing a free semaphore
		)
		return(SYSERR);

	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	theSem->key   = SFREE;
	theSem->flags = Q_FLAG;
	
	if ( nonempty( theSem ) )
		{
		while( ( theProc = (PROC_ID)GetFirst( (Q_ID)theSemaphore )) != (PROC_ID)EMPTY)
			ready( theProc, RESCHNO );
		resched();
		}
	
	// --- BT: return this structure to the Free list!
	
	RestoreA4AndSR(a4,sr);
	return(OK);
	
#undef theSem
}
