/* send.c - send */

#include <Globals.h>

/*------------------------------------------------------------------------
 *  send  --  send a message to another process
 *------------------------------------------------------------------------
 */
SYSCALL	send( PROC_ID theProcess, WORD msg)
{
	short	sr;
	long	a4;
	QItem	*qItm;
#define theProc ((Process *)theProcess)

	if (isbadpid(theProc) ||
		(theProc->pstate == PRFREE)
		//|| theProc->phasmsg != 0
		)
		return(SYSERR);
	
	a4 = SaveA4AndLoadGlobals();
	sr = disable();

	//theProc->pmsg = msg;
	//theProc->phasmsg = TRUE;
	if ((qItm = (QItem *)NewQueue()) == (QItem *)SYSERR)
		return(SYSERR);
	
	*((long *)&qItm->flags) = msg;				// BT: msg covers flags, size, & key fields
	Enqueue( (Q_NODE)qItm, theProc->msgQueue );	// Send the message along..
	
	switch (theProc->pstate)	// IF receiver is waiting, start it
	{
	case PRTRECV:
		unsleep( theProcess );
		// Fall through..
	case PRRECV:
		ready( theProcess, RESCHYES );
	}
	
	
	RestoreA4AndSR(a4,sr);
	return(OK);
}
