/* unsleep.c - unsleep */

#include <Globals.h>

/*------------------------------------------------------------------------
 * unsleep  --  remove  process from the sleep queue prematurely
 *------------------------------------------------------------------------
 */

SYSCALL	unsleep( PROC_ID theProcess )
{
	short sr; 
	long a4;
#define theProc ((Process *)theProcess)
	QItem *Next;

    
	if ( isbadpid( theProcess ) ||
		( theProc->pstate != PRSLEEP &&
		  theProc->pstate != PRTRECV)
		)
		return(SYSERR);
		
	a4 = SaveA4AndLoadGlobals();
	sr = disable();

	
	Next = (QItem *)((char *)theProcess + ((QItem *)theProcess)->next);
	
	if ( Next != (QItem *)xinuGlobs.sleepQ )
		Next->key += ((QItem *)theProcess)->key;
		
	Dequeue( (Q_NODE)theProcess );
	
	if ( nonempty(xinuGlobs.sleepQ) )
		sltop = (short *) &(((QItem *)((long)xinuGlobs.sleepQ + ((QItem *)xinuGlobs.sleepQ)->next))->key);
	else
		areProcsAsleep = FALSE;

    RestoreA4AndSR(a4,sr);
	return(OK);
}



