/* wait.c - wait */

#include <Globals.h>

/*------------------------------------------------------------------------
 * wait  --  make current process wait on a semaphore
 *------------------------------------------------------------------------
 */

SYSCALL wait( SEM_ID theSemaphore )
{
	short sr; 
	long a4;
#define theSem ((QItem *)theSemaphore)
#define theProc ((Process *)(xinuGlobs.CurPID))

	if ( isbadsem( theSem ) ||
		 theSem->key == SFREE )
		return SYSERR;
	
	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	if ( --(theSem->key) < 0 )
		{
		theProc->pstate	= PRWAIT;
		theProc->psem	= theSemaphore;
		Enqueue( (Q_NODE)(xinuGlobs.CurPID), (Q_ID)theSemaphore );
		resched();
		}
	
	RestoreA4AndSR(a4,sr);
	return OK;

#undef theSem
#undef theProc
}




