//
// Xinu Dynamic System Memory Alloc/Dealloc
//
// Bryan Turner
//

//
// --- BT: These procedures have not been tested...
//

#include <Globals.h>

QItem *NewMem;		// Pointer to beginning of unused space (grows downward)
QItem FirstFree;	// Freed up blocks for re-allocation (circular buffer)

void XMemInit()
{
	NewMem = *((QItem **)0x5D36);	// --- NOT ROM 2.1 Compatable!
	FirstFree.next = FirstFree.prev = 0;
}

//
// Allocates memory from the dynamic pool
//
QItem *XAlloc( short size )
{
	QItem *temp = 0;
	
	size += 7;
	size >>= 3;						// Force to next 8-Byte boundary
	size--;							// 0..255 8-Byte chunks allowed (2K max allocation)
	
	if ( size > 255 )
		return (void *)SYSERR;
	
	if ( FirstFree.next != FirstFree.prev )		// If a free block exists...
		{
		QItem *walk = &FirstFree + FirstFree.next;
		
		// While size of current level's block is not correct, go to the next
		while ( (walk != &FirstFree) && (walk->size != size) )
			walk += walk->next;
		
		if ( (walk != &FirstFree) && (walk->size == size) )
			{
			temp = walk;
			(walk + walk->prev)->next += walk->next;
			(walk + walk->next)->prev += walk->prev;
			}
		}
	
	if ( !temp )					// Could not reallocate needed mem
		{
		temp = NewMem;
		NewMem -= (size+1)<<3;		// Shift Free pointer down
		}
		
	*((long *)temp) = 				// Clears both prev & next in one shot
	temp->flags = temp->key = 0;	// Clear important parts of memory block

	return temp;
}

void XMemFree( Q_NODE theData )
{
	// --- If memory is the very bottom of heap space, release it for TI-OS
	//     to use...
	Enqueue( theData, (Q_ID)&FirstFree );
}
